unit Indy10TestMain;

{$mode objfpc}{$H+}

interface

uses
  Classes, SysUtils, FileUtil, Forms, Controls, Graphics, Dialogs, StdCtrls,
  IdComponent,IdUDPClient, IdGlobal,lconvencoding;


type

  TByteArr = array of byte;

  { TForm1 }

  TForm1 = class(TForm)
    CheckBoxWithArgument: TCheckBox;
    ConnectButton: TButton;
    EditArgType: TEdit;
    EditArgValue: TEdit;
    EditAdress: TEdit;
    EditHost: TEdit;
    EditPort: TEdit;
    Label1: TLabel;
    Label10: TLabel;
    Label9: TLabel;
    LabelFinalByte: TLabel;
    LabelValByte: TLabel;
    LabelAdrByte: TLabel;
    Label2: TLabel;
    Label3: TLabel;
    Label4: TLabel;
    Label5: TLabel;
    Label6: TLabel;
    Label7: TLabel;
    Label8: TLabel;
    LabelTypByte: TLabel;
    SendButton: TButton;
    UDPc: TIdUDPClient;
    Memo1: TMemo;
    procedure ConnectButtonClick(Sender: TObject);
    procedure EditHostChange(Sender: TObject);
    procedure EditPortChange(Sender: TObject);
    procedure SendButtonClick(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure UDPcConnected(Sender: TObject);
    procedure UDPcDisconnected(Sender: TObject);
    procedure UDPcStatus(ASender: TObject; const AStatus: TIdStatus;
      const AStatusText: string);
  private
    { private declarations }
    function StringToOSCFormat(InpStr: String): TByteArr;
    function FloatToOSCFormat(InpStr: String): TByteArr;
    procedure ShowOSCBuffer(B : TIdBytes; L:TLabel; Desc : String);
  public
    { public declarations }
  end;


var
  Form1: TForm1;



implementation

{$R *.lfm}

{ TForm1 }

procedure TForm1.FormCreate(Sender: TObject);
begin
  Form1.Top:=1; Form1.Left:=1;
  Form1.Width:=1100; Form1.Height:=700;
  Memo1.ScrollBars:=ssAutoBoth;
  Memo1.Clear;
  SendButton.Enabled:=False;
  CheckBoxWithArgument.Checked:=False;

  LabelAdrByte.Caption:='';
  LabelTypByte.Caption:='';
  LabelValByte.Caption:='';
  LabelFinalByte.Caption:='';

  EditHost.Caption:='127.0.0.1';
  EditPort.Caption:='12345';

  EditAdress.Caption:='/modeCustom';
  EditArgType.Caption:=',f';
  EditArgValue.Caption:='0.58';

  UDPc.Host:=EditHost.Caption;
  UDPc.Port:=StrToInt(EditPort.Caption);

end;

procedure TForm1.UDPcConnected(Sender: TObject);
begin
  SendButton.Enabled:=True;
  ConnectButton.Enabled:=False;
end;

procedure TForm1.UDPcDisconnected(Sender: TObject);
begin
  Memo1.Append('Disconectet.');
  SendButton.Enabled:=False;
end;

procedure TForm1.UDPcStatus(ASender: TObject; const AStatus: TIdStatus;
  const AStatusText: string);
begin
  Memo1.Append('Aktueller Status: '+AStatusText);
end;

function TForm1.StringToOSCFormat(InpStr: String): TByteArr;
var i: integer;
    InpStrLength,OutLength : Integer;

begin

  InpStrLength:= length(InpStr);

  OutLength :=  InpStrLength + ( 4- InpStrLength mod 4);

  SetLength(Result, OutLength);
  for i := 0 to OutLength - 1 do Result[i]:=0;
  for i := 0 to InpStrLength - 1 do Result[i] := ord(InpStr[I + 1]);

end;

function TForm1.FloatToOSCFormat(InpStr: String): TByteArr;
Var floatZahl : single;  //single entspricht 4 Byte-Größe (also 32 Bit)
    Code : Integer;

begin

  SetLength(Result, 4);

  Val(InpStr,floatZahl,Code);

  result[3] := PCardinal(@floatZahl)^ and $FF;
  result[2] := (PCardinal(@floatZahl)^ shr 8) and $FF;
  result[1] := (PCardinal(@floatZahl)^ shr 16) and $FF;
  result[0] := (PCardinal(@floatZahl)^ shr 24) and $FF;

end;

procedure TForm1.ShowOSCBuffer(B: TIdBytes; L: TLabel; Desc : String);
Var i,n : integer;
    s : String;
begin
  s:='';

  n:=0;
  for i:=0 to length(B)-1 do begin
     if n=4 then begin
       n:=0;
       s:=s+chr(13);
     end;
     s := s+
          intToStr(B[i])+
          ' ('+
          ISO_8859_1ToUTF8(chr(B[i])) +
          ')   ';
     inc(n);
  end;

  L.Caption:=Desc+chr(13)+chr(13)+s;

end;

procedure TForm1.ConnectButtonClick(Sender: TObject);
begin

  try
  Memo1.Clear;
  Memo1.Append('Try_Connect...');

  Memo1.Append('Host: ' +UDPc.Host + '  Port: '+ inttostr(UDPc.Port));
  UDPc.Connect;

  except
  Memo1.Append('Error');
  end;

end;

procedure TForm1.EditHostChange(Sender: TObject);
begin
  UDPc.Host:=EditHost.Caption;
end;

procedure TForm1.EditPortChange(Sender: TObject);
begin
  UDPc.Port:=StrToInt(EditPort.Caption);
end;


procedure TForm1.SendButtonClick(Sender: TObject);
var Lfin, LAdr, LTyp, LVal : Integer;
    i : integer;
    FinalBufferToSend,AdrBuffer,TypBuffer,ValBuffer : TIdBytes;

begin

  LabelAdrByte.Caption:='';
  LabelTypByte.Caption:='';
  LabelValByte.Caption:='';
  LabelFinalByte.Caption:='';

  if CheckBoxWithArgument.Checked=false then begin

    AdrBuffer:=StringToOSCFormat(EditAdress.Caption);
    ShowOSCBuffer(AdrBuffer, Form1.LabelAdrByte,'OSC-Bytes from Adress:');
    Memo1.Append('The Message is sendet without the Argument');

    FinalBufferToSend:= AdrBuffer;
  end else begin

    AdrBuffer:=StringToOSCFormat(EditAdress.Caption);
    ShowOSCBuffer(AdrBuffer, Form1.LabelAdrByte,'OSC-Bytes from Adress:');

    TypBuffer:=StringToOSCFormat(EditArgType.Caption);
    ShowOSCBuffer(TypBuffer, Form1.LabelTypByte,'OSC-Bytes from Arg.-Type:');

    ValBuffer:=FloatToOSCFormat(EditArgValue.Caption);
    ShowOSCBuffer(ValBuffer, Form1.LabelValByte,'OSC-Bytes from Arg.-Value:');


    // Begin to add all Buffers in the Final-Buffer
    LAdr:=length(AdrBuffer);
    LTyp:=length(TypBuffer);
    LVal:=length(ValBuffer);
    Lfin:=LAdr+LTyp+LVal;
    SetLength(FinalBufferToSend,LFin);

    //showMessage(IntToStr(Lfin));

    for i:=0 to Lfin-1 do FinalBufferToSend[i]:=0;

    for i:= 0 to LAdr-1 do begin
      FinalBufferToSend[i]:=AdrBuffer[i];
    end;

    for i:= 0 to LTyp-1 do begin
      FinalBufferToSend[i+LAdr]:=TypBuffer[i];
    end;

    for i:= 0 to LVal-1 do begin
      FinalBufferToSend[i+LAdr+LTyp]:=ValBuffer[i];
    end;

  end;

  ShowOSCBuffer(FinalBufferToSend, Form1.LabelFinalByte,'OSC-Bytes to send:');
  UDPc.SendBuffer(FinalBufferToSend);

end;


end.

